/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow.blocks.manipulation;

import baka.dataflow.DataBlock;
import java.awt.event.ActionEvent;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *
 * @author madda
 */
public class Filter extends DataBlock {

    JTextField filterField;
    String filter;
    boolean isRegexp = false;
    JCheckBox regexpCheckbox;

    public Filter() {
        this.description = "Filters input against filter.";
        this.category = "manipulation";
        this.maxOutputCount = 1;
        this.outputCount = 1;
        this.maxInputCount = 1;
        this.inputCount = 1;
        this.type = "Filter";
        constructProperties();
        this.propertiesPanel.setName(this.type);

        filterField = new JTextField(filter);
        //filterField.addActionListener(this);
        filterField.getDocument().addDocumentListener(new DocumentListener() {

            public void insertUpdate(DocumentEvent e) {
                change();
            }

            public void removeUpdate(DocumentEvent e) {
                change();
            }

            public void changedUpdate(DocumentEvent e) {
                change();
            }

            public void change() {
                filter = filterField.getText();
            }
        });
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Filter against:"), filterField));

        this.regexpCheckbox = new JCheckBox();
        this.regexpCheckbox.setActionCommand("regexp");
        this.regexpCheckbox.addActionListener(this);
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Is RegExp"), regexpCheckbox));
    }

    @Override
    public void processInput() {
        String line = "";
        if ((line = inputBus.readSpecific(0)) != null) {
            boolean found = false;
            if (this.isRegexp) {
                System.out.println("filtrujem podla regularneho vyrazu");
                Pattern pat = Pattern.compile(this.filter);
                Matcher matcher = pat.matcher(line);
                if (matcher.find()) {
                    found = true;
                }
            } else {
                System.out.println("filtrujem podla textu, hladam:"+this.filter+" v texte:"+line);
                if (line.contains(this.filter)) {
                    found = true;
                }
            }

            if (found) {
                System.out.println("nasiel som posielam vystupy");
                outputBus.writeToAll(line);
            }
        }
//        if ((line = inputBus.readSpecific(0)) != null) {
//            System.out.println("Filtrujem riadok=\"" + line + "\" a hladam=" + this.filter);
//            if (line.contains(this.filter)) {
//                System.out.println("naisel som.");
//                outputBus.writeToAll(line);
//            }
//        }
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        if (e.getActionCommand().equals("regexp")) {
            //System.out.println("regexp checkbox action :"+this.regexpCheckbox.isSelected());
            this.isRegexp = this.regexpCheckbox.isSelected();
        }
    }

    @Override
    public Element getXML(Element e, Document doc) {
        super.getXML(e, doc);
        Attr filter = doc.createAttribute("filter");
        filter.setValue(this.filter);
        e.setAttributeNode(filter);

        Attr isRef = doc.createAttribute("isRegexp");
        isRef.setValue(String.valueOf(this.isRegexp));
        e.setAttributeNode(isRef);
        return e;
    }

    @Override
    public void loadXML(Element e) {
        super.loadXML(e);
        this.filter = e.getAttribute("filter");
        String isReg = e.getAttribute("isRegexp");
        if (isReg.equals("true")) {
            this.isRegexp = true;
        } else {
            this.isRegexp = false;
        }
    }

    @Override
    public void setLoadedSettings() {
        super.setLoadedSettings();
        this.filterField.setText(this.filter);
        this.regexpCheckbox.setSelected(this.isRegexp);
    }

    @Override
    public void resetBlockState() {
    }

    @Override
    public void finalizeBlockWork() {
    }
}
