/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow.blocks.manipulation;

import baka.dataflow.DataBlock;
import java.awt.event.ActionEvent;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *
 * @author madda
 */
public class Glue extends DataBlock {

    JTextField glueField;
    String glue;
    boolean keepLastInput;
    JCheckBox lastInputCheckbox;
    String[] lastInputValues;

    public Glue() {
        this.category = "manipulation";
        this.description = "Merge inputs to the one output.";
        this.maxOutputCount = 1;
        this.outputCount = 1;
        this.maxInputCount = 5;
        this.inputCount = 1;
        this.type = "Glue";
        constructProperties();
        this.propertiesPanel.setName(this.type);

        glueField = new JTextField(glue);
        //glueField.addActionListener(this);
        glueField.getDocument().addDocumentListener(new DocumentListener() {

            public void insertUpdate(DocumentEvent e) {
                change();
            }

            public void removeUpdate(DocumentEvent e) {
                change();
            }

            public void changedUpdate(DocumentEvent e) {
                change();
            }

            public void change() {
                glue = glueField.getText();
            }
        });
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Glue:"), glueField));

        this.lastInputCheckbox = new JCheckBox();
        this.lastInputCheckbox.setActionCommand("lastInput");
        this.lastInputCheckbox.addActionListener(this);
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Wait for LineEnd"), lastInputCheckbox));

    }

    @Override
    public void processInput() {
        String output = "";
        String separator = System.getProperty("line.separator");
        String inputs[] = new String[this.inputCount];
        int lineEndCount = 0;
        for (int i = 0; i < this.inputCount; i++) {
            inputs[i] = this.inputBus.readSpecific(i);
            if (inputs[i].equals(separator)) {
                lineEndCount++;
            }
        }
        if (keepLastInput) {
            // ani jeden vstup nie je lineend normalne zlepim -- deje sa to nizsie


            if (lineEndCount > 0) {
                if (lineEndCount < this.inputCount) {
                    // nieco je lineend nieco nie -- to co je pozeram co tam bolo predtym a znova vratim lineend do zbernice
                    for (int i = 0; i < inputs.length; i++) {
                        if (inputs[i].equals(separator)) {
                            inputs[i] = lastInputValues[i];
                            this.inputBus.returnToSpecific(i, separator);
                        }
                    }
                } else {
                    // vsetky su lineend vymazem lineendy zo zbernice a vycistim si lastValues
                    for (int i = 0; i < this.inputCount; i++) {
                        lastInputValues[i] = "";
                    }
                    System.out.println("vsetky INPUTY BOLI LINEEND cistim zbernicu.");
                    return;
                }
            }




        }
        for (int i = 0; i < inputs.length; i++) {
            if (!output.equals("")) {
                output += glue;
            }
            output += inputs[i];
            lastInputValues[i] = inputs[i];
        }
        System.out.println("Glue posiela na vystup: " + output);
        this.outputBus.writeToAll(output);
    }

//    @Override
//    public boolean hasInputs() {
//        if (keepLastInput) {
//            return true;
//        } else {
//            return super.hasInputs();
//        }
//    }

    @Override
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        if (e.getActionCommand().equals("lastInput")) {
            //System.out.println("regexp checkbox action :"+this.regexpCheckbox.isSelected());
            this.keepLastInput = this.lastInputCheckbox.isSelected();
        }
    }


    @Override
    public Element getXML(Element e, Document doc) {
        super.getXML(e, doc);
        Attr glue = doc.createAttribute("glue");
        glue.setValue(this.glue);
        e.setAttributeNode(glue);

        Attr keepLastInputA = doc.createAttribute("keepLastInput");
        keepLastInputA.setValue(String.valueOf(this.keepLastInput));
        e.setAttributeNode(keepLastInputA);
        return e;
    }

    @Override
    public void loadXML(Element e) {
        super.loadXML(e);
        this.glue = e.getAttribute("glue");
        String keepLastInputA = e.getAttribute("keepLastInput");
        if (keepLastInputA.equals("true")) {
            this.keepLastInput = true;
        } else {
            this.keepLastInput = false;
        }
    }

    @Override
    public void setLoadedSettings() {
        super.setLoadedSettings();
        this.glueField.setText(this.glue);
        this.lastInputCheckbox.setSelected(this.keepLastInput);
    }

    @Override
    public void resetBlockState() {
        lastInputValues = new String[this.inputCount];
        for (int i = 0; i < lastInputValues.length; i++) {
            lastInputValues[i] = "";
        }
    }

    @Override
    public void finalizeBlockWork() {

    }
}
