/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow.blocks.manipulation;

import baka.dataflow.DataBlock;
import java.awt.event.ActionEvent;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *
 * @author madda
 */
public class LineNumber extends DataBlock {

    private int LineNumber;
    private boolean atBegin;
    private JCheckBox positionCheckBox;

    public LineNumber() {
        this.description = "Add order number to each input.";
        this.category = "manipulation";
        this.type = "LineNumber";
        this.maxOutputCount = 1;
        this.outputCount = 1;
        this.maxInputCount = 1;
        this.inputCount = 1;
        constructProperties();
    }

    @Override
    public void constructProperties() {
        super.constructProperties();
        this.positionCheckBox = new JCheckBox();
        this.positionCheckBox.setEnabled(true);
        this.positionCheckBox.setActionCommand("placePosition");
        this.positionCheckBox.addActionListener(this);
        JComponent row = this.createPropertiesPanelRow(new JLabel("Place at beginning"), positionCheckBox);
        this.propertiesPanel.add(row);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        if (e.getActionCommand().equals("placePosition")) {
            this.atBegin = this.positionCheckBox.isSelected();
        }
    }

    @Override
    public Element getXML(Element e, Document doc) {
        super.getXML(e, doc);

        Attr position = doc.createAttribute("position");
        position.setValue(String.valueOf(this.atBegin));
        e.setAttributeNode(position);
        return e;
    }

    @Override
    public void loadXML(Element e) {
        super.loadXML(e);
        String isReg = e.getAttribute("position");
        if (isReg.equals("true")) {
            this.atBegin = true;
        } else {
            this.atBegin = false;
        }
    }

    @Override
    public void setLoadedSettings() {
        super.setLoadedSettings();
        this.positionCheckBox.setSelected(this.atBegin);
    }

    @Override
    public void processInput() {
        String line = "";
        if ((line = inputBus.readSpecific(0)) != null) {
            this.LineNumber++;
            if (atBegin) {
                line = String.valueOf(this.LineNumber) + ". " + line;
            } else {
                line = line + " " + String.valueOf(this.LineNumber) + ".";
            }
            outputBus.writeToAll(line);
        }
    }

    @Override
    public void resetBlockState() {
        this.LineNumber = 0;
    }

    @Override
    public void finalizeBlockWork() {
    }
}
