/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow.blocks.manipulation;

import baka.dataflow.DataBlock;
import com.drew.imaging.ImageMetadataReader;
import com.drew.imaging.ImageProcessingException;
import com.drew.metadata.Metadata;
import com.drew.metadata.jpeg.JpegDescriptor;
import com.drew.metadata.jpeg.JpegDirectory;
import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author madda
 */
public class MetaMiner extends DataBlock {

    public MetaMiner() {
        this.description = "Filters input against filter.";
        this.category = "manipulation";
        this.maxOutputCount = 4;
        this.outputCount = 4;
        this.minOutputCount = 4;
        this.maxInputCount = 1;
        this.inputCount = 1;
        this.type = "MetaMiner";
        constructProperties();
        this.propertiesPanel.setName(this.type);
    }

    @Override
    public void processInput() {
        String line = "";
        if ((line = inputBus.readSpecific(0)) != null) {
            Metadata metadata = null;
            File jpegFile = null;
            try {
                jpegFile = new File(line);
                metadata = ImageMetadataReader.readMetadata(jpegFile);
            } catch (ImageProcessingException ex) {
                Logger.getLogger(MetaMiner.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(MetaMiner.class.getName()).log(Level.SEVERE, null, ex);
            }

            this.outputBus.writeSpecific(0, jpegFile.getName());
            Date date = new Date(jpegFile.lastModified());
            this.outputBus.writeSpecific(1, date.toString());
            if (metadata != null) {
                JpegDirectory directory = metadata.getDirectory(JpegDirectory.class);

                JpegDescriptor descriptor = new JpegDescriptor(directory);

                String width = descriptor.getImageWidthDescription();
                String height = descriptor.getImageHeightDescription();
                //System.out.println("Image width:" + width + " height:" + height);
                this.outputBus.writeSpecific(2, width);
                this.outputBus.writeSpecific(3, height);
            }

        }

    }

    @Override
    public void resetBlockState() {
    }

    @Override
    public void finalizeBlockWork() {
    }
}
