/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package baka.dataflow.blocks.target;

import baka.dataflow.DataBlock;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *
 * @author madda
 */
public class LineWriter extends DataBlock implements ActionListener {

    private String filePath;
    private String fileName;
    private JFileChooser fc;
    JTextField choosedFile;
    FileOutputStream out;
    OutputStreamWriter ow;
    boolean fileInitialized = false;

    public LineWriter() {
        FileOutputStream out = null;
        this.maxOutputCount = 0;
        this.outputCount = 0;
        this.maxInputCount = 1;
        this.inputCount = 1;
        this.type = "LineWriter";
        this.category = "target";
        this.description = "Write each input to the file as new line.";
        constructProperties();
        this.propertiesPanel.setName(this.type);

        choosedFile = new JTextField(filePath);
        choosedFile.setEditable(false);
        JPanel filechooser = new JPanel(new GridLayout(1, 2));
        filechooser.add(choosedFile);
        JButton fchooserButton = new JButton("...");
        fchooserButton.setActionCommand("ChooseFile");
        fchooserButton.addActionListener(this);
        filechooser.add(fchooserButton);
        this.propertiesPanel.add(this.createPropertiesPanelRow(new JLabel("Selected File"), filechooser));
    }

    @Override
    public void setBlockFile(String file) {
        this.filePath = file;
    }

    private void initializeFile() {
        try {
            out = new FileOutputStream(this.filePath);
            ow = new OutputStreamWriter(out);
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, "Error on " + this.type + "\n" + ex.toString(), "Error", JOptionPane.ERROR_MESSAGE);
            return;
        }
        fileInitialized = true;
    }

    @Override
    public void processInput() {
        String separator = System.getProperty("line.separator");
        try {
            String line = "";
            if ((line = inputBus.readSpecific(0)) != null) {
                ow.write(line + separator);
            }
        } catch (Exception e) {//Catch exception if any
            System.err.println("Process input Error: " + e.getMessage());
        }
    }

    private void finalizeFile() {
        if (fileInitialized) {
            try {
                ow.close();
                out.close();
            } catch (IOException ex) {
            }
            System.out.println("dozapisoval som zatvaram file.");
        }

    }

    @Override
    public void actionPerformed(ActionEvent e) {
        super.actionPerformed(e);
        if (e.getSource() instanceof JButton) {
            JButton source = (JButton) e.getSource();
            if (source.getActionCommand().equals("ChooseFile")) {
                fc = new JFileChooser();

                int returnVal = fc.showSaveDialog(null);


                if (returnVal == JFileChooser.APPROVE_OPTION) {
                    File file = fc.getSelectedFile();
                    this.filePath = file.getPath();
                    this.fileName = file.getName();
                    choosedFile.setText(file.getName());
                }

            }

        }

    }

    @Override
    public Element getXML(Element e, Document doc) {
        super.getXML(e, doc);
        Attr file = doc.createAttribute("fileName");
        file.setValue(this.fileName);
        e.setAttributeNode(file);

        Attr fileP = doc.createAttribute("filePath");
        fileP.setValue(this.filePath);
        e.setAttributeNode(fileP);
        return e;
    }

    @Override
    public void loadXML(Element e) {
        super.loadXML(e);
        this.fileName = e.getAttribute("fileName");
        this.filePath = e.getAttribute("filePath");
    }

    @Override
    public void setLoadedSettings() {
        super.setLoadedSettings();
        this.choosedFile.setText(this.fileName);
    }

    @Override
    public void resetBlockState() {
        initializeFile();
    }

    @Override
    public void finalizeBlockWork() {
        finalizeFile();
    }
}
