/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 *
 */
package baka.gui;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;
import javax.swing.JComponent;
import javax.swing.TransferHandler;

/**
 *
 * @author madda
 */
public class BlockTransferHandler extends TransferHandler {

    DataFlavor blockFlavor = DataFlavor.stringFlavor;
    PalleteBlock source;

    public boolean importData(JComponent c, Transferable t) {
        String type;
        if (canImport(c, t.getTransferDataFlavors())) {
            GraphicCanvas canvas = (GraphicCanvas) c;
            try {
                type = (String) t.getTransferData(blockFlavor);
                //Set the component to the new picture.
                canvas.dropNewBlock(type);
                return true;
            } catch (UnsupportedFlavorException ufe) {
                System.out.println("importData: unsupported data flavor");
            } catch (IOException ioe) {
                System.out.println("importData: I/O exception");
            }
        }
        return false;
    }

    public int getSourceActions(JComponent c) {
        return COPY;
    }

    protected Transferable createTransferable(JComponent c) {
        source = (PalleteBlock) c;
        return new BlockTransferable(source.getType());
    }

    public boolean canImport(JComponent c, DataFlavor[] flavors) {
        for (int i = 0; i < flavors.length; i++) {
            if (blockFlavor.equals(flavors[i])) {
                return true;
            }
        }
        return false;
    }

    protected void exportDone(JComponent c, Transferable data, int action) {
        this.source = null;
    }

    class BlockTransferable implements Transferable {

        private String type;

        public BlockTransferable(String s) {
            this.type = s;
        }

        public DataFlavor[] getTransferDataFlavors() {
            return new DataFlavor[]{blockFlavor};
        }

        public boolean isDataFlavorSupported(DataFlavor flavor) {
            return blockFlavor.equals(flavor);
        }

        public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
            if (!isDataFlavorSupported(flavor)) {
                throw new UnsupportedFlavorException(flavor);
            }
            return this.type;
        }
    }
}
